#import "FlutterBridgefyPlugin.h"
#import <BFTransmitter/BFTransmitter.h>

@implementation FlutterBridgefyPlugin{
    BFTransmitter *transmitter;
}

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {

  FlutterMethodChannel* methodChannel =
      [FlutterMethodChannel methodChannelWithName:@"flutter_bridgefy"
            binaryMessenger:[registrar messenger]];

  FlutterEventChannel *eventChannel =
       [FlutterEventChannel eventChannelWithName:@"flutter_bridgefy_result"
            binaryMessenger:[registrar messenger]];
  
  FlutterBridgefyPlugin* instance = [[FlutterBridgefyPlugin alloc] init];

  [registrar addApplicationDelegate:instance];
  [registrar addMethodCallDelegate:instance channel:methodChannel];
  [eventChannel setStreamHandler:instance];
}

FlutterEventSink _eventSink;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    [BFTransmitter setLogLevel:BFLogLevelTrace];
    transmitter.delegate = self;

    return YES;
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"init" isEqualToString:call.method]){
        NSLog(@"Method:init");
        transmitter = [[BFTransmitter alloc] initWithApiKey:call.arguments];
        result(nil);
    } else if ([@"start" isEqualToString:call.method]){
        NSLog(@"Method:start");
        [transmitter start];
        result(nil);
    } else if ([@"backgroundModeEnabled" isEqualToString:call.method]){
        NSLog(@"Method:backgroundModeEnabled");
        if(call.arguments!=nil){
            self.transmitter.backgroundModeEnabled = [call.arguments boolValue];
        }
        result(nil);
    } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
